<?php
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * A visual interface object for editing and viewing a session's pipeline.
 *
 * @author Tschipper
 */
class SessionEditorWidget {

    // properties
    private $loadedSession;
    private $selectedStep;

    public function __construct() {
    }

    public function init() {
        $stringPipeline = "";
        $stringPipelineType = "";
        $stringPipelineUpdated = "";
        $numberOfSteps = 0;

        if (is_array($this->loadedSession->pipeline)) {
            foreach ($this->loadedSession->pipeline as $object) {
                $stringPipeline .= "$object->uid,";
                $stringPipelineType .= get_class($object) . ",";
                $stringPipelineUpdated .= "0,";
                $numberOfSteps++;
            }
        } else {
            $stringPipeline = $this->loadedSession->pipeline;
            $stringPipelineType = $_POST['pipelineTypes'];
            $stringPipelineUpdated = $_POST['pipelineUpdatedField'];
        }
        ?>
        <br />

        <div id="sequencer" class="largeFrame">
            <div class="largeTitle">Name <?php echo $this->loadedSession->title; ?></div>
            
            <div id="seqContent" class="innerLargeFrame">
                <div id="seqContentWrapper"></div>
            </div>

            <div class="controls">
                <input type="button" id="moveSelectedL" value="< Move" class="smallButton"  onClick="moveStep(-1);" />
                <input type="button" id="moveSelectedR" value="Move >" class="smallButton"  onClick="moveStep(1);" />
                <input type="button" id="editSelected" value="Edit step" class="smallButton" onClick="editStep();" />
                <input type="button" id="deleteSelected" value="Delete step" class="smallButton" onClick="deleteStep();" />
                <input type="button" value="debug_save" onClick="savePipeline(true);" />
            </div>
            
            <div id="hiddenInputs">
                <input type="hidden" id="selectedStepField" value="" />
                <input type="hidden" id="pipelineStringField" value="<?php echo $stringPipeline; ?>" />
                <input type="hidden" id="pipelineTypeField" value="<?php echo $stringPipelineType; ?>" />
                <input type="hidden" id="pipelineUpdatedField" value="<?php echo $stringPipelineUpdated; ?>" />
                <input type="hidden" id="numSteps" value="<?php echo $numberOfSteps; ?>" />
                <input type="hidden" id="sessionField" value="<?php echo $this->loadedSession->uid; ?>" />
                <input type="hidden" id="sessionTitleField" value="<?php echo $this->loadedSession->title; ?>" />
            </div>
        </div>

        
        <?php
    }

    public function Javascript() {
        ?>
        <script type="text/javascript" src="js/generalScripts.js"></script>
        <script type="text/javascript" src="js/sequencerScripts.js"></script>
        <script type="text/javascript" src="js/jquery.js"></script>
        <script type="text/javascript">

            var ddMenu = new DDMenu();
            
            $(document).ready(function() {
                loadSequencer();
                ddMenu.Init();
            });
        </script>
        <?php
    }

    public function LoadSession() {   // Initialize variables on page load.
		// Redirect if no session is set
        if (!isset($_POST['objectUid'])) {
            redirect("selectSession.php");
        }
        
        $results = Session::get(array("uid"=> $_POST['objectUid']));
		//print_r($results);
        if (!empty($results)) {
            if ($results[0]->evaluate()) {
                $this->loadedSession = $results[0];
            }
        }
        else {
            // Throw error and quit if no results found
            die("No session with that UID found!");
        }
    }

    public function HandlePostData() {
                
    }

}
?>
